<?php

// Id used to identify this page within functions.
$PageID = "USER_ADD";

require_once "common.inc";

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "mgmnt.inc";
require_once "language.inc";
require_once "layout.inc";

$error = '';

if(isset($_REQUEST['user_name']) && isset($_REQUEST['stage']))
{
	$sql = "SELECT user_name FROM users WHERE user_name='" . $_REQUEST['user_name'] . "'";
	$sqlResult = mysql_query($sql);
	$row = mysql_fetch_array($sqlResult);
	if($row['user_name'])
	{
		//header("Location: user_add.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&error=username");
		$error = $langText['ERROR_USERNAMEEXISTS'] . ' ' . $langText['ERROR_CHOOSEANOTHER'];
		$_REQUEST['stage'] = 1;
	} 
	
	if (!allowable_username($_REQUEST['user_name'])) {
		$error = $langText['ERROR_UNAME_NOT_ALLOWED'] . ' ' . $langText['ERROR_CHOOSEANOTHER'];
		$_REQUEST['stage'] = 1;
	}
}

if(isset($_REQUEST['user_card_number']) && $_REQUEST['user_card_number'] != "" && isset($_REQUEST['stage']))
{
	if(is_last_char($_REQUEST['user_card_number'], $config['card_number_suffix']))
		$mysql_card_number = chop_last($_REQUEST['user_card_number']);
	else
		$mysql_card_number = $_REQUEST['user_card_number'];

	$sql = "SELECT user_card_number FROM users WHERE user_card_number='" . $mysql_card_number . "'";
	$sqlResult = mysql_query($sql);
	$row = mysql_fetch_array($sqlResult);
	if($row['user_card_number'])
	{
		//header("Location: user_add.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&error=username");
		$error = $langText['ERROR_CARDEXISTS'] . ' ' . $langText['ERROR_CHOOSEANOTHER'];
		$_REQUEST['stage'] = 1;
	}
}

$required = explode(',', $config['user_required_fields']);
foreach ($required as $key => $value) {
	$required[$key] = trim($value);
}

if(!isset($_REQUEST['error']) && isset($_REQUEST['stage']))
{
	//header("Location: user_add.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&error=ast");
	foreach ($required as $key => $value)
	{
		if (!isset($_REQUEST[$value]) || $_REQUEST[$value] == '')
		{
			$error = $langText['ERROR_FILL_CRITERIA'];
			$_REQUEST['stage'] = 1;
		}
	}
}

/*if(isset($_REQUEST['error']) && $_REQUEST['error'] == "username")
	$user_name_error = "<span class='error'>" . $langText['ERROR_USERNAMEEXISTS'] . "<br />" . $langText['ERROR_CHOOSEANOTHER'] . "<p /></span>";
elseif(isset($_REQUEST['error']) && $_REQUEST['error'] == "ast")
	$user_name_error = "<span class='error'>" . $langText['ERROR_NOT_ENOUGH_INPUT'] . "<br />" . $langText['ERROR_FILL_CRITERIA'] . "<p /></span>";
*/

$onLoad = "if (document.user_add.user_given_names) document.user_add.user_given_names.focus();";

layout_header(array('onload' => $onLoad));

if(!isset($_REQUEST['stage']) || $_REQUEST['stage'] == 1)
{
	layout_page_title($error, 'error');
	layout_wizard_start($langText['HEADER'].": [".$langText['STEP_1']."]", $langText['STEP1_DESC']);

	?>

	<form name='user_add' action='user_add.php' method='post' onSubmit="return document.user_add.check.value;">

		<input type='hidden' name='stage' value='<?php echo (isset($_REQUEST['add_more']) ? "end" : 2)?>'>
		<?php if(isset($_REQUEST['add_more'])) print "<input type='hidden' name='add_more' value=1>";?>
		<input type='hidden' name='id' value='<?php echo $_REQUEST['id']?>'>
		<input type='hidden' name='auth' value='<?php echo $_REQUEST['auth']?>'>
		<input type='hidden' name='ENABLE' value='<?php if(isset($_REQUEST['ENABLE'])) print $_REQUEST['ENABLE'];?>'>
		<input type='hidden' name='BORROW' value='<?php if(isset($_REQUEST['BORROW'])) print $_REQUEST['BORROW'];?>'>
		<input type='hidden' name='BORROWED_BOOKS' value='<?php if(isset($_REQUEST['BORROWED_BOOKS'])) print $_REQUEST['BORROWED_BOOKS'];?>'>
		<input type='hidden' name='ADD' value='<?php if(isset($_REQUEST['ADD'])) print $_REQUEST['ADD'];?>'>
		<input type='hidden' name='DELETE' value='<?php if(isset($_REQUEST['DELETE'])) print $_REQUEST['DELETE'];?>'>
		<input type='hidden' name='GROUP_MANAGEMENT' value='<?php if(isset($_REQUEST['GROUP_MANAGEMENT'])) print $_REQUEST['GROUP_MANAGEMENT'];?>'>
		<input type='hidden' name='CAST' value='<?php if(isset($_REQUEST['CAST'])) print $_REQUEST['CAST'];?>'>
		<input type='hidden' name='print_receipt' value='<?php if(isset($_REQUEST['print_receipt'])) print $_REQUEST['print_receipt'];?>'>
		<input type='hidden' name='user_language' value='<?php if(isset ($_REQUEST['user_language'])) echo $_REQUEST['user_language']?>'>
		<input type='hidden' name='user_date_format' value='<?php if(isset ($_REQUEST['user_date_format'])) echo $_REQUEST['user_date_format']?>'>

		<?php

		foreach($_REQUEST as $key => $value)
		{
			if(is_numeric($key) && $value == "on" && is_group_manager($key))
			{
				print "<input type='hidden' name='".$key."' value='".$value."'>";
			}
		}

		?>

		<table border="0" cellspacing="2" cellpadding="0">
			<tr>
				<td colspan="3">
					<?php layout_page_info($langText['USER_PERSONAL_DETAILS']) ?>
				</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>
			<tr>
				<td align="left" valign="top">
					<?php echo $langText['USER_GIVEN_NAMES'] ?>:
					<?php if (in_array('user_given_names', $required)) echo '*' ?>
				</td>
				<td width="25">&nbsp;</td>
				<td align="left" valign="top">
					<?php echo $langText['USER_CARD_NUMBER'] ?>:
					<?php if (in_array('user_card_number', $required)) echo '*' ?>
				</td>
			</tr>
			<tr>
				<td align="left" valign="top" nowrap>
					&nbsp;&nbsp;<input type='text' name='user_given_names' size=40 maxlength=255 tabindex="1" value="<?php if (isset ($_REQUEST['user_given_names'])) echo $_REQUEST['user_given_names'] ?>">
				</td>
				<td></td>
				<td align="left" valign="top" nowrap>
					&nbsp;&nbsp;<input type='text' name='user_card_number' size=20 maxlength=255 tabindex="3" value="<?php if (isset ($_REQUEST['user_card_number'])) echo $_REQUEST['user_card_number'] ?>">
				</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>
			<tr>
				<td align="left" valign="top">
					<?php echo $langText['USER_SURNAME']; ?>:
					<?php if (in_array('user_surname', $required)) echo '*' ?>
				</td>
				<td></td>
				<td align="left" valign="top">
				<?php

					if(check_priv("ADMIN") && !isset($_REQUEST['add_more']))
					{
						echo $langText['USER_NAME'] . ':';

						if (in_array('user_name', $required)) {
							echo '*';
						}
					}

				?>
				</td>
			</tr>
			<tr>
				<td align="left" valign="top">
					&nbsp;&nbsp;<input type='text' name='user_surname' size=40 maxlength=255 tabindex="2" value="<?php if (isset ($_REQUEST['user_surname'])) echo $_REQUEST['user_surname'] ?>">
				</td>
				<td></td>
				<td align="left" valign="top">
				<?php

					if(check_priv("ADMIN") && !isset($_REQUEST['add_more']))
					{
						$uname = 1; //for tabindex calculation

						?>
						&nbsp;&nbsp;<input type='text' name='user_name' size=12 maxlength=8 tabindex="4" value="<?php if (isset ($_REQUEST['user_name'])) echo $_REQUEST['user_name'] ?>">
						<?php
					}
					else {
						$uname = 0;
					}

				?>
				</td>
			</tr>

			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>

			<tr>
				<!-- ADDRESS DETAILS -->
				<td colspan="3">
					<?php layout_page_info($langText['USER_ADDRESS_DETAILS'])?>
				</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>
			<tr>
				<td align="left" valign="top">
					<?php echo $langText['USER_POSTAL_ADDRESS'] ?>:
					<?php if (in_array('user_postal_address', $required)) echo '*' ?>
				</td>
				<td width="25">&nbsp;</td>
				<td align="left" valign="top">
					<?php echo $langText['USER_POSTAL_CODE'] ?>:
					<?php if (in_array('user_postal_code', $required)) echo '*' ?>
				</td>
			</tr>
			<tr>
				<td rowspan="4" align="left" valign="top">
					&nbsp;&nbsp;<textarea name="user_postal_address" cols="35" rows="3" tabindex="<?php echo (4 + $uname) ?>"><?php if (isset ($_REQUEST['user_postal_address'])) echo $_REQUEST['user_postal_address'] ?></textarea>
				</td>
				<td rowspan="4"></td>
				<td align="left" valign="top">
					&nbsp;&nbsp;<input type='text' name='user_postal_code' size=20 maxlength=255 tabindex="<?php echo (5 + $uname) ?>" value="<?php if (isset ($_REQUEST['user_postal_code'])) echo $_REQUEST['user_postal_code'] ?>">
				</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td align="left" valign="top">
					<?php echo $langText['USER_TOWN'] ?>:
					<?php if (in_array('user_town', $required)) echo '*' ?>
				</td>
			</tr>
			<tr>
				<td align="left" valign="top">
					&nbsp;&nbsp;<input type='text' name='user_town' size=20 maxlength=255 tabindex="<?php echo (6 + $uname) ?>" value="<?php if (isset ($_REQUEST['user_town'])) echo $_REQUEST['user_town'] ?>">
				</td>
			</tr>

			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>

			<tr>
				<!-- CONTACT DETAILS -->
				<td colspan="3">
					<?php layout_page_info($langText['USER_CONTACT_DETAILS']) ?>
				</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>
			<tr>
				<td align="left" valign="top">
					<?php echo $langText['USER_EMAIL'] ?>:
					<?php if (in_array('user_email', $required)) echo '*' ?>
				</td>
				<td width="25">&nbsp;</td>
				<td align="left" valign="top">
					<?php echo $langText['USER_PHONE_HOME'] ?>:
					<?php if (in_array('user_phone_home', $required)) echo '*' ?>
				</td>
			</tr>
			<tr>
				<td align="left" valign="top" nowrap>
					&nbsp;&nbsp;<input type='text' name='user_email' size=40 maxlength=255 tabindex="<?php echo (7 + $uname) ?>" value="<?php if (isset ($_REQUEST['user_email'])) echo $_REQUEST['user_email'] ?>">
				</td>
				<td></td>
				<td align="left" valign="top">
					&nbsp;&nbsp;<input type='text' name='user_phone_home' size=20 maxlength=255 tabindex="<?php echo (8 + $uname) ?>" value="<?php if (isset ($_REQUEST['user_phone_home'])) echo $_REQUEST['user_phone_home'] ?>">
				</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>
			<tr>
				<td colspan="2"></td>
				<td align="left" valign="top">
					<?php echo $langText['USER_PHONE_MOBILE'] ?>:
					<?php if (in_array('user_phone_mobile', $required)) echo '*' ?>
				</td>
			</tr>
			<tr>
				<td colspan="2"></td>
				<td align="left" valign="top">
					&nbsp;&nbsp;<input type='text' name='user_phone_mobile' size=20 maxlength=255 tabindex="<?php echo (9 + $uname) ?>" value="<?php if (isset ($_REQUEST['user_phone_mobile'])) echo $_REQUEST['user_phone_mobile'] ?>">
				</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
			</tr>
			<tr>
				<td colspan="3" align="right" valign="top">
					<input type="hidden" name="check" value="0" />
					<input class="button" type="button" onClick="document.user_add.check.value = 1; document.user_add.submit();" tabindex="<?php echo (10 + $uname) ?>" value='<?php echo $langText['BUTTON_NEXT'] ?>&nbsp;&gt;&gt;'>
				</td>
			</tr>

		</table>

	</form>

	<?php
	layout_wizard_stop();
}
elseif($_REQUEST['stage'] == 2)
{

	// Check for expected variables, depending on user CAST
	/*if(check_priv("ADMIN"))
	{
		if(!isset($_REQUEST['user_real_name']) || !isset($_REQUEST['user_name']) || !isset($_REQUEST['user_email']) || !isset($_REQUEST['user_address']))
			error("url dismatch");
	}
	elseif(check_priv("POWER"))
	{
		if(!isset($_REQUEST['user_real_name']) || !isset($_REQUEST['user_email']) || !isset($_REQUEST['user_address']))
			error("url dismatch");
	}*/

	layout_page_title($error, 'error');

	layout_wizard_start($langText['HEADER'].": [".$langText['STEP_2']."]", $langText['STEP2_DESC']);

	/*
	if(!isset($_REQUEST['user_name']) || $_REQUEST['user_name'] == "")
		$stage = "end";
	else
		$stage = 3;
	*/

	?>

	<form name='user_add' action='user_add.php' method='post'>

		<input type='hidden' name='id' value='<?php echo $_REQUEST['id']?>'>
		<input type='hidden' name='auth' value='<?php echo $_REQUEST['auth']?>'>
		<input type='hidden' name='user_given_names' value='<?php echo $_REQUEST['user_given_names']?>'>
		<input type='hidden' name='user_surname' value='<?php echo $_REQUEST['user_surname']?>'>
		<input type='hidden' name='user_card_number' value='<?php echo $_REQUEST['user_card_number']?>'>
		<input type='hidden' name='user_name' value='<?php if(isset($_REQUEST['user_name'])) echo $_REQUEST['user_name']?>'>
		<input type='hidden' name='user_postal_address' value='<?php echo $_REQUEST['user_postal_address']?>'>
		<input type='hidden' name='user_postal_code' value='<?php echo $_REQUEST['user_postal_code']?>'>
		<input type='hidden' name='user_town' value='<?php echo $_REQUEST['user_town']?>'>
		<input type='hidden' name='user_phone_home' value='<?php echo $_REQUEST['user_phone_home']?>'>
		<input type='hidden' name='user_phone_mobile' value='<?php echo $_REQUEST['user_phone_mobile']?>'>
		<input type='hidden' name='user_email' value='<?php echo $_REQUEST['user_email']?>'>
		<input type='hidden' name='user_language' value='<?php if(isset ($_REQUEST['user_language'])) echo $_REQUEST['user_language']?>'>
		<input type='hidden' name='user_date_format' value='<?php if(isset ($_REQUEST['user_date_format'])) echo $_REQUEST['user_date_format']?>'>
		<input type='hidden' name='print_receipt' value='<?php if(isset($_REQUEST['print_receipt'])) print $_REQUEST['print_receipt'];?>'>
		<input type='hidden' name='stage' value='3'>

		<table border="0" cellspacing="0" cellpadding="4">

			<tr>
				<td align="right" valign="top">
					<?php layout_page_info($langText['ASSIGN_PRIVS']) ?>
				</td>
				<td></td>
			</tr>
			<tr>
				<td colspan="2" height="6"></td>
			</tr>

			<tr>
				<td align="right" valign="center"><?php echo $langText['USER_PRIV_ENABLED'] ?>:</td>
				<td align="left" valign="center"><input type='checkbox' name='ENABLE'<?php if (isset ($_REQUEST['ENABLE']) && $_REQUEST['ENABLE'] == "on") echo " checked" ?>></td>
			</tr>

			<?php if(check_priv("BORROW") && check_priv("RETURN")) { ?>

			<tr>
				<td align="right" valign="center"><?php echo $langText['USER_PRIV_BORROWRETURN'] ?>:</td>
				<td align="left" valign="center"><input type='checkbox' name='BORROW'<?php if (isset ($_REQUEST['BORROW']) && $_REQUEST['BORROW'] == "on") echo " checked" ?>></td>
			</tr>

			<?php } if(check_priv("BORROWED_BOOKS")) { ?>

			<tr>
				<td align="right" valign="center"><?php echo $langText['USER_PRIV_VIEWBORROWED'] ?>:</td>
				<td align="left" valign="center"><input type='checkbox' name='BORROWED_BOOKS'<?php if (isset ($_REQUEST['BORROWED_BOOKS']) && $_REQUEST['BORROWED_BOOKS'] == "on") echo " checked" ?>></td>
			</tr>

			<?php } if(check_priv("ADD") && check_priv("EDIT")) { ?>

			<tr>
				<td align="right" valign="center"><?php echo $langText['USER_PRIV_ADDEDIT'] ?>:</td>
				<td align="left" valign="center"><input type='checkbox' name='ADD'<?php if (isset ($_REQUEST['ADD']) && $_REQUEST['ADD'] == "on") echo " checked" ?>></td>
			</tr>

			<?php } if(check_priv("DELETE")) { ?>

			<tr>
				<td align="right" valign="center"><?php echo $langText['USER_PRIV_DELETE'] ?>:</td>
				<td align="left" valign="center"><input type='checkbox' name='DELETE'<?php if (isset ($_REQUEST['DELETE']) && $_REQUEST['DELETE'] == "on") echo " checked" ?>></td>
			</tr>

			<?php } if(check_priv("ADMIN") && check_priv("GROUP_MANAGEMENT") && $_REQUEST['user_name'] != "") { ?>

			<tr>
				<td align="right" valign="center"><?php echo $langText['USER_PRIV_GROUP_MANAGEMENT'] ?>:</td>
				<td align="left" valign="center"><input type='checkbox' name='GROUP_MANAGEMENT'<?php if (isset ($_REQUEST['GROUP_MANAGEMENT']) && $_REQUEST['GROUP_MANAGEMENT'] == "on") echo " checked" ?>></td>
			</tr>

			<?php } ?>

			<tr>
				<td colspan=2>&nbsp;</td>
			</tr>
			<tr>
				<td align="right" valign="top">
					<?php layout_page_info($langText['SELECT_CAST']) ?>
				</td>
				<td></td>
			</tr>
			<tr>
				<td colspan="2" height="6"></td>
			</tr>

			<?php if(check_priv("ADMIN") && isset($_REQUEST['user_name']) && $_REQUEST['user_name'] != "") {	?>

			<tr>
				<td align="right" valign="center"><?php echo $langText['USER_CAST_ADMIN'] ?>:</td>
				<td align="left" valign="center"><input type='radio' name='CAST' value='ADMIN' <?php if (isset ($_REQUEST['CAST']) && $_REQUEST['CAST'] == "ADMIN") echo " checked" ?>></td>
			</tr>
			<tr>
				<td align="right" valign="center"><?php echo $langText['USER_CAST_POWER'] ?>:</td>
				<td align="left" valign="center"><input type='radio' name='CAST' value='POWER' <?php if (isset ($_REQUEST['CAST']) && $_REQUEST['CAST'] == "POWER") echo " checked" ?>></td>
			</tr>

			<?php } ?>

			<tr>
				<td align="right" valign="center"><?php echo $langText['USER_CAST_NORMAL'] ?>:</td>
				<td align="left" valign="center"><input type='radio' name='CAST' value='NORMAL' <?php if ((isset ($_REQUEST['CAST']) && $_REQUEST['CAST'] == "NORMAL") || $_REQUEST['CAST'] == "") echo " checked" ?>></td>
			</tr>
			<tr>
				<td colspan=2>&nbsp;</td>
			</tr>

			<tr>
				<td align="right" valign="top">
					<?php layout_page_info($langText['ATTACH_USER']) ?>
				</td>
				<td></td>
			</tr>
			<tr>
				<td colspan="2" height="6"></td>
			</tr>

			<?php

			$res = mysql_query("SELECT groups.group_id, groups.group_name
								FROM groups, linkage
								WHERE groups.group_id=linkage.group_id
									&& linkage.user_id=".USER_ID."
									&& linkage.group_manager=1
								ORDER BY groups.group_name ASC");

			while($row = mysql_fetch_array($res))
			{

			?>

			<tr>
				<td align="right" valign="center"><?php echo $row['group_name'] ?></td>
				<td align="left" valign="center"><input type='checkbox' name='<?php echo $row['group_id']?>'<?php if (isset ($_REQUEST[$row['group_id']]) && $_REQUEST[$row['group_id']] == "on") echo " checked" ?>></td>
			</tr>


			<?php

			}

			?>

			<tr>
				<td colspan=2>&nbsp;</td>
			</tr>

			<tr>
				<td align="right" valign="bottom" colspan=2>
				<input class='button' type='button' value='&lt;&lt;&nbsp;<?php echo $langText['BUTTON_BACK'] ?>' onCLick='document.user_add.stage.value="1"; document.user_add.submit();'>
				&nbsp;&nbsp;
				<input class='button' type='submit' value='<?php echo $langText['BUTTON_NEXT'] ?>&nbsp;&gt;&gt;'>
				</td>
			</tr>
		</table>
	</form>

	<?php
	layout_wizard_stop();
}
elseif($_REQUEST['stage'] == 3)
{
	layout_page_title($error, 'error');

	layout_wizard_start($langText['HEADER'].": [".$langText['STEP_3']."]", $langText['STEP3_DESC']);
	?>
	<form name='user_add' action='user_add.php' method='post'>

		<input type='hidden' name='id' value='<?php echo $_REQUEST['id']?>'>
		<input type='hidden' name='auth' value='<?php echo $_REQUEST['auth']?>'>
		<input type='hidden' name='ENABLE' value='<?php if(isset($_REQUEST['ENABLE'])) print $_REQUEST['ENABLE'];?>'>
		<input type='hidden' name='BORROW' value='<?php if(isset($_REQUEST['BORROW'])) print $_REQUEST['BORROW'];?>'>
		<input type='hidden' name='BORROWED_BOOKS' value='<?php if(isset($_REQUEST['BORROWED_BOOKS'])) print $_REQUEST['BORROWED_BOOKS'];?>'>
		<input type='hidden' name='ADD' value='<?php if(isset($_REQUEST['ADD'])) print $_REQUEST['ADD'];?>'>
		<input type='hidden' name='DELETE' value='<?php if(isset($_REQUEST['DELETE'])) print $_REQUEST['DELETE'];?>'>
		<input type='hidden' name='GROUP_MANAGEMENT' value='<?php if(isset($_REQUEST['GROUP_MANAGEMENT'])) print $_REQUEST['GROUP_MANAGEMENT'];?>'>
		<input type='hidden' name='CAST' value='<?php echo $_REQUEST['CAST']?>'>
		<input type='hidden' name='user_given_names' value='<?php echo $_REQUEST['user_given_names']?>'>
		<input type='hidden' name='user_surname' value='<?php echo $_REQUEST['user_surname']?>'>
		<input type='hidden' name='user_card_number' value='<?php echo $_REQUEST['user_card_number']?>'>
		<input type='hidden' name='user_name' value='<?php if(isset($_REQUEST['user_name'])) echo $_REQUEST['user_name']?>'>
		<input type='hidden' name='user_postal_address' value='<?php echo $_REQUEST['user_postal_address']?>'>
		<input type='hidden' name='user_postal_code' value='<?php echo $_REQUEST['user_postal_code']?>'>
		<input type='hidden' name='user_town' value='<?php echo $_REQUEST['user_town']?>'>
		<input type='hidden' name='user_phone_home' value='<?php echo $_REQUEST['user_phone_home']?>'>
		<input type='hidden' name='user_phone_mobile' value='<?php echo $_REQUEST['user_phone_mobile']?>'>
		<input type='hidden' name='user_email' value='<?php echo $_REQUEST['user_email']?>'>
		<input type='hidden' name='stage' value='end'>

		<?php

		foreach($_REQUEST as $key => $value)
		{
			if(is_numeric($key) && $value == "on" && is_group_manager($key))
			{
				print "<input type='hidden' name='".$key."' value='".$value."'>";
			}
		}


		?>

		<table border="0" cellspacing="13" cellpadding="0">
			<tr>
				<td align="right" valign="top"><?php echo $langText['USER_LANGUAGE'] ?>:</td>
				<td align="left" valign="top">
					<select name="user_language">
					<?php

						for ($i = 0; $i < $lang->count; $i++)
						{
							if (isset ($_REQUEST['user_language']) && $_REQUEST['user_language'] == $i + 1)
							{
								$selected = " selected";
							}
							elseif ($config['language'] == $lang->id[$i] && $_REQUEST['user_language'] == '')
							{
								$selected = " selected";
							}
							else {
								$selected = "";
							}

							print "<option value='" . $lang->id[$i] . "'" . $selected . ">" . $lang->name[$i] . "</option>\n";
						}

					?>
					</select>
				</td>
			</tr>
			<tr>
				<td align="right" valign="top"><?php echo $langText['USER_DATE_FORMAT'] ?>:</td>
				<td align="left" valign="top">
					<input type='text' name='user_date_format' value='<?php echo $config['dateformat']?>'>
				</td>
			</tr>
			<tr>
				<td colspan=2>&nbsp;</td>
			</tr>
			<tr>
				<td align="right" valign="bottom" colspan=2>
					<input class='button' type='button' value='&lt;&lt;&nbsp;<?php echo $langText['BUTTON_BACK'] ?>' onCLick='document.user_add.stage.value="2"; document.user_add.submit();'>
					&nbsp;&nbsp;
					<input class='button' type='submit' value='[ <?php echo $langText['BUTTON_FINISH'] ?> ]'>
				</td>
			</tr>
		</table>

	</form>

	<?php

	layout_wizard_stop();
}


elseif($_REQUEST['stage'] == "end")
{
	$password = password_generator();

	if(isset($_REQUEST['user_name']) && $_REQUEST['user_name'] != "")
	{
		$result = mysql_query("SELECT user_name FROM users WHERE user_name='" . $_REQUEST['user_name'] . "'");
		if(mysql_num_rows($result))
		{
			error("session violation");
		}
	}

	$ENABLE="";
	$BORROW="";
	$BORROWED_BOOKS="";
	$ADD="";
	$DELETE="";
	$GROUP_MANAGEMENT="";

	if(isset($_REQUEST['ENABLE']) && $_REQUEST['ENABLE'] == "on")
		$ENABLE = "ENABLE";

	if(isset($_REQUEST['BORROW']) && $_REQUEST['BORROW'] == "on")
	{
		if(!check_priv("BORROW"))
			error("session violation");
		else
			$BORROW = "BORROW";
	}

	if(isset($_REQUEST['BORROWED_BOOKS']) && $_REQUEST['BORROWED_BOOKS'] == "on")
	{
		if(!check_priv("BORROWED_BOOKS"))
			error("session violation");
		else
			$BORROWED_BOOKS = "BORROWED_BOOKS";
	}

	if(isset($_REQUEST['ADD']) && $_REQUEST['ADD'] == "on")
	{
		if(!check_priv("ADD"))
			error("session violation");
		else
			$ADD = "ADD";
	}

	if(isset($_REQUEST['DELETE']) && $_REQUEST['DELETE'] == "on")
	{
		if(!check_priv("DELETE"))
			error("session violation");
		else
			$DELETE = "DELETE";
	}

	if(isset($_REQUEST['GROUP_MANAGEMENT']) && $_REQUEST['GROUP_MANAGEMENT'] == "on")
	{
		if(!check_priv("GROUP_MANAGEMENT"))
			error("session violation");
		else
			$GROUP_MANAGEMENT = "GROUP_MANAGEMENT";
	}

	if(!isset($_REQUEST['CAST']) || $_REQUEST['CAST'] == "")
		error("url dismatch");

	$priv = set_priv($ENABLE, $BORROW, $BORROWED_BOOKS, $ADD, $DELETE, $GROUP_MANAGEMENT);

	if(isset($_REQUEST['user_name']) && $_REQUEST['user_name'] != "")
		$md5_password = md5($password);
	else
		$password = pin_generator();

	if(isset($_REQUEST['user_name']) && $_REQUEST['user_name'] != "")
	{
		$res = mysql_query(	"INSERT INTO users
							SET
								user_given_names='" . $_REQUEST['user_given_names'] . "',
								user_surname='" . $_REQUEST['user_surname'] . "',
								user_card_number='" . $_REQUEST['user_card_number'] . "',
								user_name='" . $_REQUEST['user_name'] . "',
								user_postal_address='" . $_REQUEST['user_postal_address'] . "',
								user_postal_code='" . $_REQUEST['user_postal_code'] . "',
								user_town='" . $_REQUEST['user_town'] . "',
								user_phone_home='" . $_REQUEST['user_phone_home'] . "',
								user_phone_mobile='" . $_REQUEST['user_phone_mobile'] . "',
								user_email='" . $_REQUEST['user_email'] . "',
								user_lang='" . $_REQUEST['user_language'] . "',
								user_date_format='" . $_REQUEST['user_date_format'] . "',
								user_privileges=" . $priv . ",
								user_cast='".$_REQUEST['CAST']."',
								user_location='".USER_LOCATION."',
								user_password='" . $md5_password . "'");
	}
	else
	{
		$res = mysql_query(	"INSERT INTO users
							SET
								user_given_names='" . $_REQUEST['user_given_names'] . "',
								user_surname='" . $_REQUEST['user_surname'] . "',
								user_card_number='" . $_REQUEST['user_card_number'] . "',
								user_postal_address='" . $_REQUEST['user_postal_address'] . "',
								user_postal_code='" . $_REQUEST['user_postal_code'] . "',
								user_town='" . $_REQUEST['user_town'] . "',
								user_phone_home='" . $_REQUEST['user_phone_home'] . "',
								user_phone_mobile='" . $_REQUEST['user_phone_mobile'] . "',
								user_email='" . $_REQUEST['user_email'] . "',
								user_lang='" . $config['language'] . "',
								user_date_format='" . $config['dateformat'] . "',
								user_privileges=" . $priv . ",
								user_cast='".$_REQUEST['CAST']."',
								user_location='".USER_LOCATION."',
								user_password='" . $password . "'");
	}

	if($res)
	{
		$user_id = mysql_insert_id();

		foreach($_REQUEST as $key => $value)
		{
			if(is_numeric($key) && $value = "on" && is_group_manager($key))
			{
				if(isset($_REQUEST['BORROWED_BOOKS']) && $_REQUEST['BORROWED_BOOKS'] == "on")
					$view_borrowed = view_borrowed_allowed($key);
				else
					$view_borrowed = 0;

				mysql_query("INSERT INTO linkage
							SET user_id=".$user_id.",
								group_id=".$key.",
								group_manager=0,
								visible=1,
								view_borrowed=".$view_borrowed);
			}
		}

		if(!isset($_REQUEST['user_card_number']) || $_REQUEST['user_card_number'] == "")
		{
			mysql_query("UPDATE users SET user_card_number=".$user_id." WHERE user_id=".$user_id);
			$_REQUEST['user_card_number'] = $user_id;
		}

		if(!isset($_REQUEST['user_name']) || $_REQUEST['user_name'] == "")
		{
			mysql_query("UPDATE users SET user_name=".$_REQUEST['user_card_number']." WHERE user_id=".$user_id);
			$_REQUEST['user_name'] = $_REQUEST['user_card_number'];
		}

		/*

		Replace with appropriate when print_receipt function is working!

		if(isset($_REQUEST['print_receipt']) && $_REQUEST['print_receipt'] == "on")
			print_receipt("SOME CONTENT");
		*/

		writeLog("User added: " . $user_id . " (" . $_REQUEST['user_name'] . " - " . $_REQUEST['user_given_names']." ".$_REQUEST['user_surname'] . ")", $_REQUEST['id'], USER_ID);

		if($_REQUEST['CAST'] == "ADMIN")
			promote_to_admin($user_id);

		layout_page_title($langText['THANKYOU'], 'ok');

		layout_wizard_start($langText['HEADER'].": [".$langText['SUCCESS']."]", $langText['FINISHED_DESC']);

		layout_page_info($langText['STEP_END_USER_REGISTERED'] . ':');
		?>

			<blockquote>
			<table border="0" cellspacing="8" cellpadding="0">
				<tr>
					<td align='left' valign='bottom'>
						<?php echo $langText['USER_REAL_NAME'] ?>:
					</td>
					<td align='left' valign='bottom'>
						<b><?php echo $_REQUEST['user_given_names']." ".$_REQUEST['user_surname']?></b>
					</td>
				</tr>
				<tr>
					<td align='left'>
						<?php echo $langText['USER_NAME'] ?>:
					</td>
					<td align='left' valign='bottom'>
						<b><?php echo $_REQUEST['user_name']?></b>
					</td>
				</tr>
				<tr>
					<td align='left' valign='bottom'>
						<?php echo $langText['USER_CARD_NUMBER'] ?>:
					</td>
					<td align='left' valign='bottom'>
						<b><?php echo format_card_number($_REQUEST['user_card_number']) ?></b>
					</td>
				</tr>
				<tr>
					<td align='left' valign='middle'>
						<?php echo $langText['USER_BARCODE'] ?>:
					</td>
					<td align='left' valign='bottom'>
						<img src='perl/barcode.pl?code=<?php echo format_card_number($_REQUEST['user_card_number']) ?>' border=0 alt=''>
					</td>
				</tr>
				<tr>
					<td align='left' valign='bottom'>
						<?php echo $langText['USER_PASSWORD'] ?>:
					</td>
					<td align='left' valign='bottom'>
						<b><?php echo $password?></b>
					</td>
				</tr>
				<tr>
					<td colspan="2">&nbsp;</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td align="left" valign="bottom">

					<?php

						if (check_priv('RECEIPT_PRINTER'))
						{
							list ($header, $footer) = receipt_text('user_info', $_REQUEST['user_language']);
					?>

							<form name="print_info" method="get" action="print.php">
								<input type="hidden" name="id" value="<?php echo $_REQUEST['id'] ?>" />
								<input type="hidden" name="auth" value="<?php echo $_REQUEST['auth'] ?>" />
								<input type="hidden" name="type" value="receipt" />
								<input type="hidden" name="template" value="user_info" />
								<input type="hidden" name="card_number" value="<?php echo format_card_number($_REQUEST['user_card_number']) ?>" />
								<input type="hidden" name="real_name" value="<?php echo $_REQUEST['user_given_names']." ".$_REQUEST['user_surname']?>" />
								<input type="hidden" name="username" value="<?php echo $_REQUEST['user_name']?>" />
								<input type="hidden" name="password" value="<?php echo $password ?>" />
								<input type="hidden" name="language" value="<?php echo $_REQUEST['user_language'] ?>" />
								<input type="hidden" name="header" value="<?php echo $header ?>" />
								<input type="hidden" name="footer" value="<?php echo $footer ?>" />
								<input type="submit" class="button" name="print_info" value="<?php echo $langText['PRINT_INFO'] ?>">
							</form>

					<?php

						}

					?>

					</td>
				</tr>
			</table>
			</blockquote>

			<br />
			<hr class="hr-dashed" />
			<br />

			<form name='user_add' action='user_add.php' method='post'>

			<?php

			if(!isset($_REQUEST['user_name']) || is_numeric($_REQUEST['user_name']))
			{

			?>

				<input type='hidden' name='id' value='<?php echo $_REQUEST['id']?>'>
				<input type='hidden' name='auth' value='<?php echo $_REQUEST['auth']?>'>
				<input type='hidden' name='ENABLE' value='<?php if(isset($_REQUEST['ENABLE'])) print $_REQUEST['ENABLE'];?>'>
				<input type='hidden' name='BORROW' value='<?php if(isset($_REQUEST['BORROW'])) print $_REQUEST['BORROW'];?>'>
				<input type='hidden' name='BORROWED_BOOKS' value='<?php if(isset($_REQUEST['BORROWED_BOOKS'])) print $_REQUEST['BORROWED_BOOKS'];?>'>
				<input type='hidden' name='ADD' value='<?php if(isset($_REQUEST['ADD'])) print $_REQUEST['ADD'];?>'>
				<input type='hidden' name='DELETE' value='<?php if(isset($_REQUEST['DELETE'])) print $_REQUEST['DELETE'];?>'>
				<input type='hidden' name='GROUP_MANAGEMENT' value='<?php if(isset($_REQUEST['GROUP_MANAGEMENT'])) print $_REQUEST['GROUP_MANAGEMENT'];?>'>
				<input type='hidden' name='CAST' value='<?php echo $_REQUEST['CAST']?>'>
				<input type='hidden' name='user_date_format' value='<?php if(isset($_REQUEST['user_date_format'])) echo $_REQUEST['user_date_format']?>'>
				<input type='hidden' name='user_lang' value='<?php if(isset($_REQUEST['user_lang'])) echo $_REQUEST['user_lang']?>'>

				<?php

				foreach($_REQUEST as $key => $value)
				{
					if(is_numeric($key) && $value == "on" && is_group_manager($key))
					{
						print "<input type='hidden' name='".$key."' value='".$value."'>";
					}
				}

				?>

				<input type='submit' name='add_more' class='button' value='&lt;&lt;&nbsp;<?php echo $langText['ADD_SIMILAR_USER'] ?>'>
				&nbsp;&nbsp;&nbsp;

			<?php

			}

			?>

				<input type="button" name="new" class="button" value="<?php echo $langText['ADD_NEW_USER'] ?>&nbsp;&gt;&gt;" onClick="location.href='user_add.php?id=<?php echo $_REQUEST['id'] ?>&auth=<?php echo $_REQUEST['auth'] ?>'">
			</form>

		<?php

		layout_wizard_stop();
	}
	else
	{
		layout_page_title($langText['ERROR_DB_FAIL']);
	}

}

layout_footer();

?>
